<div id="body" class="container-fluid">
  <div class="row">
    <div class="col-24 col-xl-22 offset-xl-1 col-xxl-16 offset-xxl-4">
      <h6>Create View</h6>
      <form [formGroup]="form">
        <div class="form-row">
          <div class="form-group form-group-sm row col-24 col-lg-12">
            <label class="col-form-label col-24 col-lg-8">View Name</label>
            <div class="col-24 col-lg-16 pl-0 pl-lg-3">
              <input type="text" formControlName="displayViewName" />
              <small class="form-text" style="color:red;" *ngIf="form.get('displayViewName').touched && form.get('displayViewName').hasError('required')">View Name is required.</small>
              <!--<small class="form-text" style="color:red;" *ngIf="form.get('numberInput').touched && form.get('numberInput').hasError('invalidNumber')">Numbers accepted only!</small>-->
            </div>
          </div>
        </div>
        <div class="form-row">
          <div class="form-group form-group-sm row col-24 col-lg-12">
            <label class="form-check-inline">
              <input class="form-check-input" type="radio" name="rdPersonalView" [value]="true" checked="checked">
            </label>
            <label>Personal View</label>
          </div>
        </div>


        <dx-data-grid #columnGrid id="columnGrid"
          (onContentReady)="setSelectedRows()"
          (onRowUpdated)="getColumnAndPositions()"
          [dataSource]="availableViewColumnsList" keyExpr="dspL_COL_ID"
          [showBorders]="true" [wordWrapEnabled]="true"
          [rowAlternationEnabled]="true" [columnAutoWidth]="true">
          <dxo-sorting mode="multiple"></dxo-sorting>
          <dxo-editing mode="cell" [allowUpdating]="true"></dxo-editing>
          <dxo-scrolling mode="infinite"></dxo-scrolling>
          <dxo-selection mode="multiple" showCheckBoxesMode="always" selectAllMode="page"></dxo-selection>
          <dxi-column dataField="dspL_COL_NME" caption="Column Name" dataType="string" [allowEditing]="false"></dxi-column>
          <dxi-column [width]="100" dataField="dspL_POS" caption="Position from Left">
            <dxo-lookup [dataSource]="assignmentTypeOptions" valueExpr="id" displayExpr="name" [minWidth]="150">
            </dxo-lookup>
          </dxi-column>
        </dx-data-grid>

        <!-- <dx-data-grid [dataSource]="availableViewColumnsList" (onRowPrepared)="selectDsplVwCols($event)" keyExpr="dspL_COL_ID" [rowAlternationEnabled]="true" [showBorders]="true" [columnAutoWidth]="true"
                      [wordWrapEnabled]="true" (onSelectionChanged)="dsplVwColSelectionChangedHandler($event)">
          <dxo-sorting mode="multiple"></dxo-sorting>
          <dxo-scrolling mode="infinite"></dxo-scrolling>
          <dxo-selection mode="multiple" showCheckBoxesMode="always" selectAllMode="page"></dxo-selection>
          <dxi-column dataField="dspL_COL_NME" caption="Column Name" dataType="string"></dxi-column>
          <dxi-column [width]="100" cellTemplate="cellDsplColPosition" caption="Position from Left"></dxi-column>

          <div *dxTemplate="let data of 'cellDsplColPosition'">
            <mat-select matNativeControl [(value)]="data.value" (selectionChange)="dsplColPosSelectionChange($event)">
              <mat-option *ngFor="let option of assignmentTypeOptions" [value]="option.id">
                {{ option.name }}
              </mat-option>
            </mat-select>
          </div>
        </dx-data-grid> -->

        <div class="form-row">
          <div class="form-group form-group-sm row col-24 col-lg-12">
            <label class="col-form-label col-24 col-lg-8">First Sort By Column</label>
            <div class="col-24 col-lg-16 pl-0 pl-lg-3">
              <dx-select-box [items]="availableViewColumnsList"
                             displayExpr="dspL_COL_NME" valueExpr="dspL_COL_ID"
                             [value]="sortByCol1" formControlName="sortByCol1"
                             [searchEnabled]="true" [searchExpr]="['dspL_COL_NME']" searchMode="startswith"
                             (onValueChanged)="sortByCol1Changed($event.value)"></dx-select-box>
              <input formControlName="selectedColIds" type="hidden">
              <small class="form-text" style="color:red;" *ngIf="form.get('sortByCol1').touched && inValidSortByCol1">Sort by column should be from the selected list of columns.</small>
            </div>
          </div>
          <div class="form-group form-group-sm row col-24 col-lg-12">
            <label>Ascending order</label>
            <label class="form-check-inline">
              <input class="form-check-input" type="radio" [value]="true" name="sort1" [checked]="sortCol1Order" (click)="updateSortColumn1Asc(1)">
            </label>
            <div class="col-24 col-lg-16 pl-0 pl-lg-3">
              <label>Decending order</label>
              <label class="form-check-inline">
                <input class="form-check-input" type="radio" [value]="true" name="sort1" [checked]="!sortCol1Order" (click)="updateSortColumn1Asc(0)">
              </label>
            </div>
          </div>
        </div>
        <div class="form-row">
          <div class="form-group form-group-sm row col-24 col-lg-12">
            <label class="col-form-label col-24 col-lg-8">Then By Column</label>
            <div class="col-24 col-lg-16 pl-0 pl-lg-3">
              <dx-select-box [items]="availableViewColumnsList"
                             displayExpr="dspL_COL_NME" valueExpr="dspL_COL_ID"
                             [value]="sortByCol2" formControlName="sortByCol2"
                             [searchEnabled]="true" [searchExpr]="['dspL_COL_NME']" searchMode="startswith"
                             (onValueChanged)="sortByCol2Changed($event.value)"></dx-select-box>
              <small class="form-text" style="color:red;" *ngIf="form.get('sortByCol2').touched && inValidSortByCol2">Sort by column should be from the selected list of columns.</small>
            </div>
          </div>
          <div class="form-group form-group-sm row col-24 col-lg-12">
            <label>Ascending order</label>
            <label class="form-check-inline">
              <input class="form-check-input" type="radio" [value]="true" name="sort2" [checked]="sortCol2Order" (click)="updateSortColumn2Asc(1)">
            </label>
            <div class="col-24 col-lg-16 pl-0 pl-lg-3">
              <label>Decending order</label>
              <label class="form-check-inline">
                <input class="form-check-input" type="radio" [value]="true" name="sort2" [checked]="!sortCol2Order" (click)="updateSortColumn2Asc(0)">
              </label>
            </div>
          </div>
        </div>
        <div class="form-row">
          <div class="form-group form-group-sm row col-24 col-lg-12">
            <label class="col-form-label col-24 col-lg-8">Filter By</label>
            <div class="col-24 col-lg-16 pl-0 pl-lg-3">
              <label class="form-check-inline">
                <input class="form-check-input" type="radio" name="showAll" [checked]="!rbShowAllFilter" (click)="enableFilter(0)">
              </label>
              <label>Show all items in this view</label>
            </div>
          </div>
        </div>
        <div class="form-row">
          <div class="form-group form-group-sm row col-24 col-lg-12">
            <label class="col-form-label col-24 col-lg-8"></label>
            <div class="col-24 col-lg-16 pl-0 pl-lg-3">
              <label class="form-check-inline">
                <input class="form-check-input" type="radio" name="showAll" [checked]="rbShowAllFilter" (click)="enableFilter(1)">
                <input formControlName="rbShowAllFilter" type="hidden">
              </label>
              <label>Show items only when the following is true</label>
            </div>
          </div>
        </div>

        <div class="form-row">
          <div class="form-group form-group-sm row col-24 col-lg-12">
            <label class="col-form-label col-24 col-lg-8"></label>
            <div class="col-24 col-lg-16 pl-0 pl-lg-3">
              Show the items when column
              <dx-select-box [items]="availableViewColumnsList" style="width:200px;"
                             displayExpr="dspL_COL_NME" valueExpr="dspL_COL_ID"
                             [value]="filterCol1" formControlName="filterCol1"
                             [searchEnabled]="true" [searchExpr]="['dspL_COL_NME']" searchMode="startswith"
                             (onValueChanged)="filterCol1Changed($event.value)"></dx-select-box>
              <small class="form-text" style="color:red;" *ngIf="form.get('filterCol1').touched && rbShowAllFilter && inValidFilterCol1">Sort by column should be from the selected list of columns.</small>
            </div>
          </div>
          <div class="form-group form-group-sm row col-24 col-lg-12">
            <dx-select-box [items]="filterOperators" [value]="filterOperator1"
                           displayExpr="filtrOprDes" valueExpr="filtrOprId"
                           [disabled]="disableCodeFilter" style="width:200px;"
                           [searchEnabled]="true" [searchExpr]="['filtrOprDes']" searchMode="startswith"
                           (onValueChanged)="filterOperator1Changed($event.value)"></dx-select-box>
            <div class="col-24 col-lg-16 pl-0 pl-lg-3">
              <input type="text" formControlName="txtFilterVal1" style="width:200px;" />
            </div>
          </div>
        </div>
        <div class="form-row">
          <div class="form-group form-group-sm row col-24 col-lg-12">
            <label class="col-form-label col-24 col-lg-8"></label>
            <div class="col-24 col-lg-16 pl-0 pl-lg-3">
              <dx-select-box [items]="logicOperators" [value]="filterLogicOperator"
                             displayExpr="filtrOprDes" valueExpr="filtrOprId"
                             [disabled]="disableCodeFilter" style="width:200px;"
                             [searchEnabled]="true" [searchExpr]="['filtrOprDes']" searchMode="startswith"
                             (onValueChanged)="filterLogicChanged($event.value)"></dx-select-box>
            </div>
          </div>
        </div>
        <div class="form-row">
          <div class="form-group form-group-sm row col-24 col-lg-12">
            <label class="col-form-label col-24 col-lg-8"></label>
            <div class="col-24 col-lg-16 pl-0 pl-lg-3">
              When column
              <dx-select-box [items]="availableViewColumnsList" style="width:200px;"
                             displayExpr="dspL_COL_NME" valueExpr="dspL_COL_ID"
                             [value]="filterCol2" formControlName="filterCol2"
                             [searchEnabled]="true" [searchExpr]="['dspL_COL_NME']" searchMode="startswith"
                             (onValueChanged)="filterCol2Changed($event.value)"></dx-select-box>
              <small class="form-text" style="color:red;" *ngIf="form.get('filterCol2').touched && rbShowAllFilter && inValidFilterCol2">Sort by column should be from the selected list of columns.</small>
            </div>
          </div>
          <div class="form-group form-group-sm row col-24 col-lg-12">
            <dx-select-box [items]="filterOperators" [value]="filterOperator2"
                           displayExpr="filtrOprDes" valueExpr="filtrOprId"
                           [disabled]="disableCodeFilter" style="width:200px;"
                           [searchEnabled]="true" [searchExpr]="['filtrOprDes']" searchMode="startswith"
                           (onValueChanged)="filterOperator2Changed($event.value)"></dx-select-box>
            <div class="col-24 col-lg-16 pl-0 pl-lg-3">
              <input type="text" formControlName="txtFilterVal2" style="width:200px;" />
            </div>
          </div>
        </div>
        <br />
        <div class="form-row text-center">
          <div class="form-group form-group-sm col-12 col-md-6 col-lg-4 offset-md-6 offset-lg-8">
            <button type="button" class="btn btn-sm btn-secondary btn-block" (click)="cancelClick(eventTypeId)">
              Cancel
            </button>
          </div>
          <div class="form-group form-group-sm col-12 col-md-6 col-lg-4" [style.visibility]="btnSubmitVisible ? 'visible' : 'hidden'">
            <button type="button"  class="btn btn-sm btn-primary btn-block" (click)="submitClick()">
              Submit
            </button>
          </div>
          <div class="form-group form-group-sm col-12 col-md-6 col-lg-4" [style.visibility]="btnUpdateVisible ? 'visible' : 'hidden'">
            <button type="button" [disabled]="form.invalid" class="btn btn-sm btn-primary btn-block" (click)="updateClick()">
              Update
            </button>
          </div>
        </div>
      </form>
    </div>
  </div>
</div>
